// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBGDAMM_THREADER_H
#define _LIBGDAMM_THREADER_H


#include <glibmm.h>

// -*- C++ -*- // this is for the .hg, I realize gensig puts one in

/* threader.h
 *
 * Copyright 2006 libgdamm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or(at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <libgda/gda-threader.h>

#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GdaThreader GdaThreader;
typedef struct _GdaThreaderClass GdaThreaderClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Gda
{ class Threader_Class; } // namespace Gda

} // namespace Gnome
namespace Gnome
{

namespace Gda
{

typedef GdaThreaderFunc ThreaderFunc;

/** TODO. See http://bugzilla.gnome.org/show_bug.cgi?id=561175
 *
 * @ingroup Connection
 */

class Threader : public Glib::Object
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef Threader CppObjectType;
  typedef Threader_Class CppClassType;
  typedef GdaThreader BaseObjectType;
  typedef GdaThreaderClass BaseClassType;

private:  friend class Threader_Class;
  static CppClassType threader_class_;

private:
  // noncopyable
  Threader(const Threader&);
  Threader& operator=(const Threader&);

protected:
  explicit Threader(const Glib::ConstructParams& construct_params);
  explicit Threader(GdaThreader* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Threader();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GdaThreader*       gobj()       { return reinterpret_cast<GdaThreader*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GdaThreader* gobj() const { return reinterpret_cast<GdaThreader*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GdaThreader* gobj_copy();

private:

protected:
	Threader();
	
public:
  
  static Glib::RefPtr<Threader> create();

  
  /** 
   * @param func The function to be called in the newly created thread.
   * @param func_arg  @a func's argument.
   * @param ok_callback Callback called when @a func terminates.
   * @param cancel_callback Callback called when @a func terminates and the job has been cancelled.
   * @return The id of the new job executed in another thread.
   */
#ifdef GLIBMM_EXCEPTIONS_ENABLED
  guint start_thread(GThreadFunc func, gpointer func_arg, ThreaderFunc ok_callback, ThreaderFunc cancel_callback);
#else
  guint start_thread(GThreadFunc func, gpointer func_arg, ThreaderFunc ok_callback, ThreaderFunc cancel_callback, std::auto_ptr<Glib::Error>& error);
#endif //GLIBMM_EXCEPTIONS_ENABLED

  
  /** 
   */
  void cancel(guint job_id);
  
  
  /**
   * @par Prototype:
   * <tt>void on_my_%cancelled(guint arg1, gpointer arg2)</tt>
   */

  Glib::SignalProxy2< void,guint,gpointer > signal_cancelled();

  
  /**
   * @par Prototype:
   * <tt>void on_my_%finished(guint arg1, gpointer arg2)</tt>
   */

  Glib::SignalProxy2< void,guint,gpointer > signal_finished();


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
  virtual void on_cancelled(guint arg1, gpointer arg2);
  virtual void on_finished(guint arg1, gpointer arg2);
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


};

} // namespace Gda
} // namespace Gnome


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gnome::Gda::Threader
   */
  Glib::RefPtr<Gnome::Gda::Threader> wrap(GdaThreader* object, bool take_copy = false);
}


#endif /* _LIBGDAMM_THREADER_H */

